

from Tkinter import *
from numpy import log
import serial

WINDOW = 600

def measure(parent,canvas):
    mydata = ser.readline()
    mydata = mydata.replace('\n','')
    mydata = mydata.replace('\r','')

    if mydata.isdigit():
        mydata=int(mydata)
        B = 3750.0
        T0 = 298.15
        R0 = 10000.0
        R1 = 11200.0
        try:
            rr1 = R1 * mydata / (1024.0 - mydata)
            t = 1 / (log(rr1 / R0) / B + (1 / T0))
            t= t- 273.15
            t=round(t,1)

            r=t*5

            fred=int(255*t/40)
            fblue=int(255-255*t/40) #range0-40degree

            color = '#%02x%02x%02x' % (fred, 0,fblue)

            fred=int(255/5)
            canvas.itemconfigure("text",text=t)
            canvas.coords('oval',.5*WINDOW-r,.5*WINDOW-r, .5*WINDOW+r, .5*WINDOW+r)
            canvas.itemconfigure('oval', fill=color)
            canvas.update()
            parent.after_idle(measure,parent,canvas)
        except:
            print("error")
            return



ser = serial.Serial(
      port = "/dev/tty.usbserial-AI02RJUC",
      baudrate = 4800,
      parity = serial.PARITY_NONE,
      bytesize = serial.EIGHTBITS,
      stopbits = serial.STOPBITS_ONE,
      timeout = 1,
      xonxoff = 0,
      rtscts = 0,
      )


root = Tk()
root.title('Temperature (q to exit)')
root.bind('q','exit')
canvas = Canvas(root, width=WINDOW, height=WINDOW, background='white')
canvas.create_text(.5*WINDOW,.05*WINDOW,text="temperature",font=("Helvetica", 24),tags="text",fill="#0000b0")
myc=canvas.create_oval(.5*WINDOW-10,.5*WINDOW-10, .5*WINDOW+10, .5*WINDOW+10, tag="oval",fill="green")
canvas.pack()
root.after(100,measure,root,canvas)
root.mainloop()
